'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign2 = require('lodash/assign');

var _assign3 = _interopRequireDefault(_assign2);

var _find2 = require('lodash/find');

var _find3 = _interopRequireDefault(_find2);

var _debounce2 = require('lodash/debounce');

var _debounce3 = _interopRequireDefault(_debounce2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _loreUtils = require('lore-utils');

var _loreReactForms = require('lore-react-forms');

var _reactOnclickoutside = require('react-onclickoutside');

var _reactOnclickoutside2 = _interopRequireDefault(_reactOnclickoutside);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AutoCompleteField = function (_Field) {
  _inherits(AutoCompleteField, _Field);

  function AutoCompleteField(props) {
    _classCallCheck(this, AutoCompleteField);

    // bind component methods
    var _this = _possibleConstructorReturn(this, (AutoCompleteField.__proto__ || Object.getPrototypeOf(AutoCompleteField)).call(this, props));

    _this.handleUpdateInput = _this.handleUpdateInput.bind(_this);
    _this.handleNewRequest = _this.handleNewRequest.bind(_this);
    _this.updateOptions = _this.updateOptions.bind(_this);
    _this.renderOption = _this.renderOption.bind(_this);
    _this.filter = _this.filter.bind(_this);

    // setup debounce if configured
    var debounceDelay = _this.props.debounceDelay;
    if (debounceDelay > 0) {
      _this.updateOptions = (0, _debounce3.default)(_this.updateOptions, debounceDelay);
    }

    // if the value exists in the data, use it to set the initial search text
    var initialOption = (0, _find3.default)(props.options.data, function (option) {
      return option.id === props.data[props.name];
    });
    var searchText = initialOption ? initialOption.data[props.field] : '';

    _this.state = {
      searchText: searchText,
      isModified: false,
      options: _this.props.options,
      hasFocus: false
    };
    return _this;
  }

  _createClass(AutoCompleteField, [{
    key: 'onFocus',
    value: function onFocus() {
      this.setState({
        hasFocus: true
      });
    }
  }, {
    key: 'onBlur',
    value: function onBlur() {}
  }, {
    key: 'handleClickOutside',
    value: function handleClickOutside(event) {
      if (this.state.hasFocus) {
        this.setState({
          hasFocus: false,
          touched: true
        });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        options: this.filter(this.state.searchText)
      });
    }
  }, {
    key: 'filter',
    value: function filter(searchText) {
      if (this.props.filter) {
        return this.props.filter(searchText);
      }

      return (0, _assign3.default)({}, this.state.options, {
        state: _loreUtils.PayloadStates.RESOLVED
      });
    }

    /*
     * Change options based on user input
     */

  }, {
    key: 'updateOptions',
    value: function updateOptions(searchText) {
      this.setState({
        options: this.filter(searchText)
      });
    }
  }, {
    key: 'handleUpdateInput',
    value: function handleUpdateInput(e) {
      var searchText = e.target.value;

      this.setState({
        searchText: searchText,
        isModified: true
      });

      if (this.props.debounceDelay > 0) {
        this.setState({
          options: (0, _assign3.default)({}, this.state.options, {
            state: _loreUtils.PayloadStates.FETCHING
          })
        });
      }

      this.updateOptions(searchText);
    }
  }, {
    key: 'handleNewRequest',
    value: function handleNewRequest(item, index) {
      this.props.onChange(this.props.name, item.value);
      this.setState({
        searchText: item.text,
        hasFocus: false
      });
      this.handleUpdateInput({
        target: {
          value: item.text
        }
      });
    }
  }, {
    key: 'renderOption',
    value: function renderOption(option) {
      var _this2 = this;

      return _react2.default.createElement(
        'li',
        {
          key: option.value,
          style: { cursor: 'pointer' },
          onClick: function onClick() {
            _this2.handleNewRequest(option);
          }
        },
        _react2.default.createElement(
          'a',
          null,
          option.text
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          name = _props.name,
          errors = _props.errors,
          hintText = _props.hintText,
          label = _props.label,
          option = _props.option,
          field = _props.field;
      var _state = this.state,
          touched = _state.touched,
          isModified = _state.isModified,
          options = _state.options;


      var error = errors[name];
      var displayError = touched && error;

      var searchText = option ? isModified ? this.state.searchText : option.data[field] : this.state.searchText;

      var suggestions = null;

      function mapDataToOptions(data) {
        return data.map(function (datum) {
          return {
            value: datum.id,
            text: datum.data[field]
          };
        });
      }

      if (options.state === _loreUtils.PayloadStates.FETCHING) {
        suggestions = _react2.default.createElement(
          'li',
          { className: 'disabled' },
          _react2.default.createElement(
            'a',
            null,
            'Searching...'
          )
        );
      } else if (options.data.length > 0) {
        suggestions = mapDataToOptions(options.data).map(this.renderOption);
      } else {
        suggestions = _react2.default.createElement(
          'li',
          { className: 'disabled' },
          _react2.default.createElement(
            'a',
            null,
            'No results'
          )
        );
      }

      var className = 'form-group dropdown';
      if (this.state.hasFocus) {
        className += ' open';
      }
      if (displayError) {
        className += ' has-error';
      }

      return _react2.default.createElement(
        'div',
        { className: className },
        label ? _react2.default.createElement(
          'label',
          null,
          label
        ) : null,
        _react2.default.createElement('input', {
          type: 'text',
          value: searchText,
          onChange: this.handleUpdateInput,
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          className: 'form-control',
          placeholder: hintText
        }),
        _react2.default.createElement(
          'ul',
          { className: 'dropdown-menu col-xs-12' },
          suggestions
        ),
        displayError ? _react2.default.createElement(
          'span',
          { className: 'help-block' },
          error
        ) : null
      );
    }
  }]);

  return AutoCompleteField;
}(_loreReactForms.Field);

AutoCompleteField.propTypes = (0, _assign3.default)({}, {
  options: _react2.default.PropTypes.object.isRequired,
  debounceDelay: _react2.default.PropTypes.number,
  filter: _react2.default.PropTypes.func
});

AutoCompleteField.defaultProps = (0, _assign3.default)({}, {
  options: {
    data: []
  },
  debounceDelay: 250
});

exports.default = (0, _reactOnclickoutside2.default)(AutoCompleteField);