'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign2 = require('lodash/assign');

var _assign3 = _interopRequireDefault(_assign2);

var _find2 = require('lodash/find');

var _find3 = _interopRequireDefault(_find2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _loreReactForms = require('lore-react-forms');

var _loreUtils = require('lore-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint prefer-template: "off" */
/* eslint import/no-unresolved: "off" */
/* eslint no-shadow: "off" */

var SelectField = function (_Field) {
  _inherits(SelectField, _Field);

  function SelectField() {
    _classCallCheck(this, SelectField);

    return _possibleConstructorReturn(this, (SelectField.__proto__ || Object.getPrototypeOf(SelectField)).apply(this, arguments));
  }

  _createClass(SelectField, [{
    key: 'onChange',
    value: function onChange(event) {
      this.onBlur();

      var option = (0, _find3.default)(this.props.options.data, function (option) {
        return String(option.id) === event.target.value;
      });
      var value = option ? option.id : null;

      this.props.onChange(this.props.name, value);
      if (this.props.afterChange) {
        this.props.afterChange(this.props.onChange);
      }
    }
  }, {
    key: 'renderOption',
    value: function renderOption(option) {
      var text = option.text;
      var value = option.value;

      return _react2.default.createElement(
        'option',
        { key: value, value: value },
        text
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var name = this.props.name;
      var error = this.props.errors[name];
      var value = this.props.data[name];
      var touched = this.state.touched;

      var label = this.props.label;
      var options = this.props.options;
      var field = this.props.field;

      var displayError = touched && error;

      if (options.state === _loreUtils.PayloadStates.FETCHING) {
        return _react2.default.createElement(
          'div',
          null,
          'Loading...'
        );
      }

      function mapDataToOptions(data) {
        return data.map(function (datum) {
          return {
            value: datum.id,
            text: datum.data[field]
          };
        });
      }

      var optionsData = mapDataToOptions(options.data);

      return _react2.default.createElement(
        'div',
        { className: 'form-group ' + (displayError ? 'has-error' : '') },
        _react2.default.createElement(
          'label',
          null,
          label
        ),
        _react2.default.createElement(
          'select',
          { className: 'form-control', onChange: this.onChange, value: value },
          [this.renderOption({ value: null, text: '' })].concat(optionsData.map(this.renderOption))
        ),
        displayError ? _react2.default.createElement(
          'span',
          { className: 'help-block' },
          error
        ) : null
      );
    }
  }]);

  return SelectField;
}(_loreReactForms.Field);

SelectField.propTypes = (0, _assign3.default)({}, _loreReactForms.Field.propTypes, {
  options: _react2.default.PropTypes.object.isRequired
});

SelectField.defaultProps = (0, _assign3.default)({}, _loreReactForms.Field.defaultProps, {
  options: {
    data: []
  }
});

exports.default = SelectField;