'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _loreUtils = require('lore-utils');

var _loreReactForms = require('lore-react-forms');

var _reactOnclickoutside = require('react-onclickoutside');

var _reactOnclickoutside2 = _interopRequireDefault(_reactOnclickoutside);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* global lore */

var AutoCompleteField = function (_Field) {
  _inherits(AutoCompleteField, _Field);

  function AutoCompleteField(props) {
    _classCallCheck(this, AutoCompleteField);

    var _this = _possibleConstructorReturn(this, (AutoCompleteField.__proto__ || Object.getPrototypeOf(AutoCompleteField)).call(this, props));

    _this.handleUpdateInput = _this.handleUpdateInput.bind(_this);
    // this.handleUpdateInput = _.debounce(this.handleUpdateInput, 500);

    _this.handleNewRequest = _this.handleNewRequest.bind(_this);
    // this.handleNewRequest = _.debounce(this.handleNewRequest, 1000);

    _this.updateOptions = _this.updateOptions.bind(_this);
    _this.updateOptions = _lodash2.default.debounce(_this.updateOptions, 250);
    _this.renderOption = _this.renderOption.bind(_this);

    var initialOption = _lodash2.default.find(props.options.data, function (option) {
      console.log('props.data[props.name]: ' + props.data[props.name]);
      return option.id === props.data[props.name];
    });

    var searchText = initialOption ? initialOption.data[props.field] : '';

    _this.state = {
      searchText: searchText,
      isModified: false,
      options: _this.props.options || {
        data: [],
        query: {}
      },
      hasFocus: false
    };
    return _this;
  }

  _createClass(AutoCompleteField, [{
    key: 'onFocus',
    value: function onFocus() {
      this.setState({
        hasFocus: true
      });
    }
  }, {
    key: 'onBlur',
    value: function onBlur() {
      // this.setState({
      //   touched: true
      // });
    }
  }, {
    key: 'handleClickOutside',
    value: function handleClickOutside(event) {
      console.log('clicked outside!');
      if (this.state.hasFocus) {
        this.setState({
          hasFocus: false,
          touched: true
        });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var options = this.state.options;
      var query = options.query;
      var nextOptions = lore.store.getState().user.find[JSON.stringify(query)];
      this.setState({
        options: nextOptions || options
      });
    }
  }, {
    key: 'updateOptions',
    value: function updateOptions(searchText) {
      console.log('updateOptions: ' + searchText);
      this.setState({
        options: lore.getState('user.find', {
          where: {
            username_like: searchText
          }
        })
      });
    }
  }, {
    key: 'handleUpdateInput',
    value: function handleUpdateInput(e) {
      var searchText = e.target.value;
      console.log('handleUpdateInput: ' + searchText);
      this.setState({
        searchText: searchText,
        isModified: true,
        options: {
          state: _loreUtils.PayloadStates.FETCHING,
          data: [{
            id: 0,
            data: {
              id: 0,
              username: 'Searching...'
            }
          }],
          query: {}
        }
      });

      this.updateOptions(searchText);
    }
  }, {
    key: 'handleNewRequest',
    value: function handleNewRequest(item, index) {
      console.log('handleNewRequest');
      // this.setState({
      //   searchText: '',
      // });
      this.props.onChange(this.props.name, item.value);
      this.setState({
        searchText: item.text,
        hasFocus: false
      });
      this.handleUpdateInput({
        target: {
          value: item.text
        }
      });
    }
  }, {
    key: 'renderOption',
    value: function renderOption(option) {
      var _this2 = this;

      return _react2.default.createElement(
        'li',
        {
          key: option.value,
          style: { cursor: 'pointer' },
          onClick: function onClick() {
            _this2.handleNewRequest(option);
          }
        },
        _react2.default.createElement(
          'a',
          null,
          option.text
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var name = this.props.name;
      var error = this.props.errors[name];
      // const value = this.props.data[name];
      var touched = this.state.touched;
      var hintText = this.props.hintText;
      var label = this.props.label;
      // const disabled = this.props.disabled;
      var displayError = touched && error;

      var isModified = this.state.isModified;
      var option = this.props.option;
      var field = this.props.field;
      var searchText = option ? isModified ? this.state.searchText : option.data[field] : this.state.searchText;

      var options = this.state.options;
      // options.data = options.data || [];
      var suggestions = null;

      function mapDataToOptions(data) {
        return data.map(function (datum) {
          return {
            value: datum.id,
            text: datum.data[field]
          };
        });
      }

      // const optionsData = mapDataToOptions(options.data);
      // const dataSource = [{ value: null, text: ''}].concat(optionsData);
      // const dataSource = mapDataToOptions(options.data);
      // const filter = function(a, b, c) {
      //   return true;
      // };

      if (options.state === _loreUtils.PayloadStates.FETCHING) {
        suggestions = _react2.default.createElement(
          'li',
          { className: 'disabled' },
          _react2.default.createElement(
            'a',
            null,
            'Searching...'
          )
        );
      } else if (options.data.length > 0) {
        suggestions = mapDataToOptions(options.data).map(this.renderOption);
      } else {
        suggestions = _react2.default.createElement(
          'li',
          { className: 'disabled' },
          _react2.default.createElement(
            'a',
            null,
            'No results'
          )
        );
      }

      var className = 'form-group dropdown';
      if (this.state.hasFocus) {
        className += ' open';
      }
      if (displayError) {
        className += ' has-error';
      }

      return _react2.default.createElement(
        'div',
        { className: className },
        _react2.default.createElement(
          'label',
          null,
          label
        ),
        _react2.default.createElement('input', {
          type: 'text',
          value: searchText,
          onChange: this.handleUpdateInput,
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          className: 'form-control',
          placeholder: hintText
        }),
        _react2.default.createElement(
          'ul',
          { className: 'dropdown-menu col-xs-12' },
          suggestions
        ),
        displayError ? _react2.default.createElement(
          'span',
          { className: 'help-block' },
          error
        ) : null
      );
    }
  }]);

  return AutoCompleteField;
}(_loreReactForms.Field);

AutoCompleteField.propTypes = _lodash2.default.assign({}, {
  options: _react2.default.PropTypes.object.isRequired
});

AutoCompleteField.defaultProps = _lodash2.default.assign({}, {
  options: {
    data: []
  }
});

exports.default = (0, _reactOnclickoutside2.default)(AutoCompleteField);
module.exports = exports['default'];